require 'xcodeproj'

def source(repo)

	`git clone #{repo}`

end

module Xcconfig

	def Xcconfig.merge_files_array(files)
		
		if files == nil
			
			return nil
			
		end
			
		resources = []
		files.each do |source|
				
			resources.concat Dir[source]
				
		end
			
		return resources
		
	end

	def Xcconfig.add_groups_for_files(project,files)
		
		files.each do |path|
				
			groups = File.dirname(path).split("/")
			concate = ""
					
			groups.each do |g|
					
				concate +=	g + "/"
				group_ref = project.main_group.find_subpath(concate, true)
				group_ref.set_path(g)
					
			end
				
		end
		
	end
		
	def Xcconfig.get_or_add_file(project,file)
		
		filename = File.basename(file)
		dir = File.dirname(file)
			
		group = project.main_group.find_subpath(dir, false)
		file_ref = group.find_file_by_path(filename)
					
		unless file_ref != nil
					
			file_ref = group.new_file(filename)
					
		end 
			
		return file_ref
		
	end
		
	def Xcconfig.get_or_add_files(project, files)
		
		resources = merge_files_array(files)
				
		add_groups_for_files(project, resources)

		resources.each do |source|
					
			get_or_add_file(project,source)
					
		end
		
	end
			
	def Xcconfig.add_config_files(project, entity, config_files)
			
		# Add configuration group
				
		add_groups_for_files(project, config_files.values)
			
		config_files.each do |config,file_name|

			unless file_name == nil
					
				file = get_or_add_file(project,file_name)
						
				configuration = entity.build_configuration_list[config]
						
				unless configuration == nil
					configuration.base_configuration_reference = file
				end
					
			end
				
		end
			
	end

end